void SaveAlmProc(int num)
{
   if (num==1) {alarm1.ahour=chour; alarm1.amin=cmin; alarm1.is_enabled=c_en;}
   else if (num==2) {alarm2.ahour=chour; alarm2.amin=cmin; alarm2.is_enabled=c_en;}
   else {alarm3.ahour=chour; alarm3.amin=cmin; alarm3.is_enabled=c_en;}
   // save to EEPROM
   if (num!=3) {
    EEPROM.write(0,0xCE); //signature
    EEPROM.write(1,alarm1.ahour);
    EEPROM.write(2,alarm1.amin);
    EEPROM.write(3,alarm1.is_enabled);
    EEPROM.write(4,alarm2.ahour);
    EEPROM.write(5,alarm2.amin);
    EEPROM.write(6,alarm2.is_enabled);
   }
}

void AlarmCmdProc()
{
  char buffer[30];
  boolean is_exit=false;

  myGLCD.clrScr();

  refresh=true;

  while (!is_exit) {
     if (refresh) { 
       // header
       myGLCD.setBackColor(VGA_BLUE);
       myGLCD.setColor(VGA_BLUE);
       myGLCD.fillRect(20,20,300,40);
       myGLCD.setColor(VGA_WHITE);
       myGLCD.setFont(BigFont);
       myGLCD.print("Alarm select mode", 25, 25);
       myGLCD.setBackColor(VGA_BLACK);
       // alm1
       myGLCD.setColor(VGA_GREEN);
       sprintf(buffer,"%s %02d:%02d","A:",alarm1.ahour,alarm1.amin);
       myGLCD.print(buffer, 20, 65);
       if (alarm1.is_enabled) { myGLCD.setColor(VGA_LIME); myGLCD.print("Enabled",180,65);
       }
       else {myGLCD.setColor(VGA_RED); myGLCD.print("Disabled",180,65);}
       // alm2
       myGLCD.setColor(VGA_GREEN);
       sprintf(buffer,"%s %02d:%02d","B:",alarm2.ahour,alarm2.amin);
       myGLCD.print(buffer, 20, 115);
       if (alarm2.is_enabled) { myGLCD.setColor(VGA_LIME); myGLCD.print("Enabled",180,115);
       }
       else {myGLCD.setColor(VGA_RED); myGLCD.print("Disabled",180,115);}
       // alm3
       myGLCD.setColor(VGA_GREEN);
       sprintf(buffer,"%s %02d:%02d","C:",alarm3.ahour,alarm3.amin);
       myGLCD.print(buffer, 20, 165);
       if (alarm3.is_enabled) { myGLCD.setColor(VGA_LIME); myGLCD.print("Enabled",180,165);
       }
       else {myGLCD.setColor(VGA_RED); myGLCD.print("Disabled",180,165);}
       // borders
       myGLCD.setColor(VGA_BLUE);
       myGLCD.setBackColor(VGA_BLACK);
       myGLCD.drawRoundRect (10, 55, 310, 95); //a1
       myGLCD.drawRoundRect (10, 105, 310, 145); //a2
       myGLCD.drawRoundRect (10, 155, 310, 195); //a2
       //
       VButton (220, 200, 80, 30, 7); //exit
       refresh=false;
     }
     while (!myTouch.dataAvailable());
     myTouch.read();
     x=myTouch.getX();
     y=myTouch.getY();
     refresh=true;
     if (press_map(x,y,220, 200,300,239)) {is_exit=true;} // exit button
     else if (press_map(x,y,20, 55,320,95)) {AlarmSetProc(1);}
     else if (press_map(x,y,20, 105,320,145)) {AlarmSetProc(2);}
     else if (press_map(x,y,20, 155,320,195)) {AlarmSetProc(3);}
     else refresh=false;
  }
  myGLCD.clrScr();
}

void AlarmSetProc(int num) 
{
  boolean is_exit=false;
  int nn;

   if (num==1) {chour=alarm1.ahour; cmin=alarm1.amin; c_en=alarm1.is_enabled;}
   else if (num==2) {chour=alarm2.ahour; cmin=alarm2.amin; c_en=alarm2.is_enabled;}
   else {chour=alarm3.ahour; cmin=alarm3.amin; c_en=alarm3.is_enabled;}

  refresh=true;
  
  myGLCD.clrScr();

  while (!is_exit)
  {

   if (refresh) {
        // header
       myGLCD.setBackColor(VGA_BLUE);
       myGLCD.setColor(VGA_BLUE);
       myGLCD.fillRect(20,20,300,40);
       myGLCD.setColor(VGA_WHITE);
       myGLCD.setFont(BigFont);
       myGLCD.print("Alarm setup mode", 25, 25);
       myGLCD.setBackColor(VGA_BLACK);
     set2display(20, 60, 0, 255, 0);
      VButton (20, 200, 80, 30, 4); //save
      if (c_en) VButton (120, 200, 80, 30, 6); //disable
      else VButton (120, 200, 80, 30, 5); //enable
      VButton (220, 200, 80, 30, 7); //exit
      myGLCD.setFont(BigFont);
      if (num==1) myGLCD.print("A: ", 20,180);
      else if (num==2) myGLCD.print("B: ", 20,180);
      else myGLCD.print("C: ", 20,180);
      if (c_en) {myGLCD.setColor(VGA_LIME); myGLCD.print("Enabled ", 70,180);}
      else { myGLCD.setColor(VGA_RED); myGLCD.print("Disabled ", 70,180); }
      refresh=false;
   }
    if (myTouch.dataAvailable())
    {
      myTouch.read();
      x=myTouch.getX();
      y=myTouch.getY();
      refresh=true;
	if (press_map(x,y,20, 200,100,239)) {SaveAlmProc(num);is_exit=true;}
	else if (press_map(x,y,120, 200,200,239)) {c_en=!c_en;}
	else if (press_map(x,y,220, 200,300,239)) {is_exit=true;}
	// digits
	else if (press_map(x,y,20,60,83,160))  {nn=drawTimeMask(1);chour=chour%10+nn*10;} //1
	else if (press_map(x,y,84,60,148,160)) {nn=drawTimeMask(2);chour=chour-chour%10+nn;} //2
	else if (press_map(x,y,190,60,254,160)) {nn=drawTimeMask(3);cmin=cmin%10+nn*10;} //3
	else if (press_map(x,y,254,60,318,160)) {nn=drawTimeMask(4);cmin=cmin-cmin%10+nn;} //4
	else refresh=false;
     } 
   }
   myGLCD.clrScr();
}
